scala.reflect.api.Types

# SingletonType

#### abstract type SingletonType >: Null <: Universe.Type

The type of Scala singleton types, i.e., types that are inhabited by only one nun-null value. These include types of the forms

    C.this.type
    C.super.type
    x.type

as well as constant types.

Source
  Types.scala

Linear Supertypes
AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. SingletonType
2. AnyRef
3. Any

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Abstract Value Members

1. #### abstract def <:<(that: Universe.Type): Boolean

   Does this type conform to given type argument `that`?

   Does this type conform to given type argument `that`?

   Definition Classes
     TypeApi

2. #### abstract def =:=(that: Universe.Type): Boolean

   Is this type equivalent to given type argument `that`?

   Is this type equivalent to given type argument `that`?

   Definition Classes
     TypeApi

3. #### abstract def asSeenFrom(pre: Universe.Type, clazz: Universe.Symbol): Universe.Type

   This type as seen from prefix `pre` and class `clazz`.

   This type as seen from prefix `pre` and class `clazz`. This means: Replace all `ThisType`s of `clazz` or one of its subclasses by `pre` and instantiate all parameters by arguments of `pre`. Proceed analogously for `ThisType`s referring to outer classes.

   Example:

       scala> import scala.reflect.runtime.universe._
       import scala.reflect.runtime.universe._

       scala> class D[T] { def m: T = ??? }
       defined class D

       scala> class C extends D[Int]
       defined class C

       scala> val D = typeOf[D[_]].typeSymbol.asClass
       D: reflect.runtime.universe.ClassSymbol = class D

       scala> val C = typeOf[C].typeSymbol.asClass
       C: reflect.runtime.universe.ClassSymbol = class C

       scala> val T = D.typeParams(0).asType.toType
       T: reflect.runtime.universe.Type = T

       scala> T.asSeenFrom(ThisType(C), D)
       res0: reflect.runtime.universe.Type = scala.Int

   Definition Classes
     TypeApi

4. #### abstract def baseClasses: List[Universe.Symbol]

   The list of all base classes of this type (including its own typeSymbol) in reverse linearization order, starting with the class itself and ending in class Any.

   The list of all base classes of this type (including its own typeSymbol) in reverse linearization order, starting with the class itself and ending in class Any.

   Definition Classes
     TypeApi

5. #### abstract def baseType(clazz: Universe.Symbol): Universe.Type

   The least type instance of given class which is a super-type of this type.

   The least type instance of given class which is a super-type of this type. Example:

       class D[T]
       class C extends p.D[Int]
       ThisType(C).baseType(D) = p.D[Int]

   Definition Classes
     TypeApi

6. #### abstract def contains(sym: Universe.Symbol): Boolean

   Does this type contain a reference to given symbol?

   Does this type contain a reference to given symbol?

   Definition Classes
     TypeApi

7. #### abstract def declaration(name: Universe.Name): Universe.Symbol

   The defined or declared members with name `name` in this type; an OverloadedSymbol if several exist, NoSymbol if none exist.

   The defined or declared members with name `name` in this type; an OverloadedSymbol if several exist, NoSymbol if none exist. Alternatives of overloaded symbol appear in the order they are declared.

   Definition Classes
     TypeApi

8. #### abstract def declarations: Universe.MemberScope

   A `Scope` containing directly declared members of this type.

   A `Scope` containing directly declared members of this type. Unlike `members` this method doesn't returns inherited members.

   Members in the returned scope might appear in arbitrary order. Use `declarations.sorted` to get an ordered list of members.

   Definition Classes
     TypeApi

9. #### abstract def erasure: Universe.Type

   The erased type corresponding to this type after all transformations from Scala to Java have been performed.

   The erased type corresponding to this type after all transformations from Scala to Java have been performed.

   Definition Classes
     TypeApi

10. #### abstract def exists(p: (Universe.Type) ⇒ Boolean): Boolean

    Is there part of this type which satisfies predicate `p`?

    Is there part of this type which satisfies predicate `p`?

    Definition Classes
      TypeApi

11. #### abstract def find(p: (Universe.Type) ⇒ Boolean): Option[Universe.Type]

    Returns optionally first type (in a preorder traversal) which satisfies predicate `p`, or None if none exists.

    Returns optionally first type (in a preorder traversal) which satisfies predicate `p`, or None if none exists.

    Definition Classes
      TypeApi

12. #### abstract def foreach(f: (Universe.Type) ⇒ Unit): Unit

    Apply `f` to each part of this type, for side effects only

    Apply `f` to each part of this type, for side effects only

    Definition Classes
      TypeApi

13. #### abstract def map(f: (Universe.Type) ⇒ Universe.Type): Universe.Type

    Apply `f` to each part of this type, returning a new type.

    Apply `f` to each part of this type, returning a new type. children get mapped before their parents

    Definition Classes
      TypeApi

14. #### abstract def member(name: Universe.Name): Universe.Symbol

    The member with given name, either directly declared or inherited, an OverloadedSymbol if several exist, NoSymbol if none exist.

    The member with given name, either directly declared or inherited, an OverloadedSymbol if several exist, NoSymbol if none exist.

    Definition Classes
      TypeApi

15. #### abstract def members: Universe.MemberScope

    A `Scope` containing all members of this type (directly declared or inherited).

    A `Scope` containing all members of this type (directly declared or inherited). Unlike `declarations` this method also returns inherited members.

    Members in the returned scope might appear in arbitrary order. Use `declarations.sorted` to get an ordered list of members.

    Definition Classes
      TypeApi

16. #### abstract def normalize: Universe.Type

    Expands type aliases and converts higher-kinded TypeRefs to PolyTypes.

    Expands type aliases and converts higher-kinded TypeRefs to PolyTypes. Functions on types are also implemented as PolyTypes.

    Example: (in the below, <List> is the type constructor of List) TypeRef(pre, <List>, List()) is replaced by PolyType(X, TypeRef(pre, <List>, List(X)))

    Definition Classes
      TypeApi

17. #### abstract def substituteSymbols(from: List[Universe.Symbol], to: List[Universe.Symbol]): Universe.Type

    Substitute symbols in `to` for corresponding occurrences of references to symbols `from` in this type.

    Substitute symbols in `to` for corresponding occurrences of references to symbols `from` in this type.

    Definition Classes
      TypeApi

18. #### abstract def substituteTypes(from: List[Universe.Symbol], to: List[Universe.Type]): Universe.Type

    Substitute types in `to` for corresponding occurrences of references to symbols `from` in this type.

    Substitute types in `to` for corresponding occurrences of references to symbols `from` in this type.

    Definition Classes
      TypeApi

19. #### abstract def takesTypeArgs: Boolean

    Is this type a type constructor that is missing its type arguments?

    Is this type a type constructor that is missing its type arguments?

    Definition Classes
      TypeApi

20. #### abstract def termSymbol: Universe.Symbol

    The term symbol associated with the type, or `NoSymbol` for types that do not refer to a term symbol.

    The term symbol associated with the type, or `NoSymbol` for types that do not refer to a term symbol.

    Definition Classes
      TypeApi

21. #### abstract def typeConstructor: Universe.Type

    Returns the corresponding type constructor (e.

    Returns the corresponding type constructor (e.g. List for List[T] or List[String])

    Definition Classes
      TypeApi

22. #### abstract def typeSymbol: Universe.Symbol

    The type symbol associated with the type, or `NoSymbol` for types that do not refer to a type symbol.

    The type symbol associated with the type, or `NoSymbol` for types that do not refer to a type symbol.

    Definition Classes
      TypeApi

23. #### abstract def weak_<:<(that: Universe.Type): Boolean

    Does this type weakly conform to given type argument `that`, i.

    Does this type weakly conform to given type argument `that`, i.e., either conforms in terms of `<:<` or both are primitive number types that conform according to Section "Weak Conformance" in the spec. For example, Int weak_<:< Long.

    Definition Classes
      TypeApi

24. #### abstract def widen: Universe.Type

    If this is a singleton type, widen it to its nearest underlying non-singleton base type by applying one or more `underlying` dereferences.

    If this is a singleton type, widen it to its nearest underlying non-singleton base type by applying one or more `underlying` dereferences. If this is not a singleton type, returns this type itself.

    Example:

    class Outer { class C ; val x: C } val o: Outer <o.x.type>.widen = o.C

    Definition Classes
      TypeApi

### Concrete Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

5. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality. The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

6. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown
     ClassCastException

     if the receiver object is not an instance of the erasure of type `T0`.

7. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws ()
   Note

     not specified by SLS as a member of AnyRef

8. #### final def eq(arg0: AnyRef): Boolean

   Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

   Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

   The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

   - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
   - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
   - `null.eq(null)` returns `true`.

   When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

   returns

     `true` if the argument is a reference to the receiver object; `false` otherwise.

   Definition Classes
     AnyRef

9. #### def equals(arg0: Any): Boolean

   The equality method for reference types.

   The equality method for reference types. Default implementation delegates to `eq`.

   See also `equals` in scala.Any.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

10. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws ()
    Note

      not specified by SLS as a member of AnyRef

11. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

12. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

13. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

14. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

15. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

16. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

17. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

18. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

19. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws ()

20. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws ()

21. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws ()

### Inherited from AnyRef

### Inherited from Any

### Ungrouped